// WaveRecDlg.cpp : implementation file
//

#pragma warning(disable: 4786)

#include "stdafx.h"
#include <string>

#include "WaveRec.h"
#include "WaveRecDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int ID_TIMER1 = 100;

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CWaveRecDlg dialog

CWaveRecDlg::CWaveRecDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWaveRecDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWaveRecDlg)
	m_FileName_Rec = _T("");
	m_FileName_Play = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWaveRecDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaveRecDlg)
	DDX_Control(pDX, IDC_CHECK2, m_PStereo);
	DDX_Control(pDX, IDC_EDIT4, m_PSamplingRate);
	DDX_Control(pDX, IDC_EDIT3, m_PBits);
	DDX_Control(pDX, IDC_CHECK3, m_PLoop);
	DDX_Control(pDX, IDC_COMBO2, m_PDevice);
	DDX_Control(pDX, IDC_COMBO1, m_RDevice);
	DDX_Control(pDX, IDC_BUTTON4, m_PlayBtnStop);
	DDX_Control(pDX, IDC_BUTTON3, m_PlayBtnStart);
	DDX_Control(pDX, IDC_BUTTON2, m_RecBtnStop);
	DDX_Control(pDX, IDC_BUTTON1, m_RecBtnStart);
	DDX_Text(pDX, IDC_EDIT1, m_FileName_Rec);
	DDX_Text(pDX, IDC_EDIT2, m_FileName_Play);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWaveRecDlg, CDialog)
	//{{AFX_MSG_MAP(CWaveRecDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaveRecDlg message handlers

BOOL CWaveRecDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_FileName_Rec = "C:\\Temp\\Stream44.wav";
	m_FileName_Play = "C:\\Temp\\Stream44.wav";

	UpdateData(false);
	VCInit();
	
	int i;
	for (i = 0; i < m_WaveIn->GetDeviceCount(); i++)
		m_RDevice.AddString(m_WaveIn->GetDeviceName(i));
	m_RDevice.SetCurSel(0);

	for (i = 0; i < m_WaveOut->GetDeviceCount(); i++)
		m_PDevice.AddString(m_WaveOut->GetDeviceName(i));
	m_PDevice.SetCurSel(0);

	SetTimer(ID_TIMER1, 500, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWaveRecDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CWaveRecDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWaveRecDlg::VCInit()
{
	m_WaveIn.CreateInstanceLic(__uuidof(vcproWaveInDeviceX), L"0");
	m_WaveRiff_Rec.CreateInstanceLic(__uuidof(vcproWaveRiffX), L"0");
	m_WaveRiff_Play.CreateInstanceLic(__uuidof(vcproWaveRiffX), L"0");
	m_WaveOut.CreateInstanceLic(__uuidof(vcproWaveOutDeviceX), L"0");

	m_WaveIn->MinActiveTime = true;
	m_WaveRiff_Rec->IsInput = false;

	m_WaveRiff_Play->IsFormatProvider = true;
	m_WaveRiff_Play->RealTime = true;

	SetLink(m_WaveIn, m_WaveRiff_Rec);
	SetLink(m_WaveRiff_Play, m_WaveOut);
}

void CWaveRecDlg::VCUninit()
{
	Rec(false);
	Play(false);
}

void CWaveRecDlg::SetLink(IvcproProviderPtr provider, IvcproConsumerPtr consumer)
{
	provider->AddConsumer(consumer);
}

void CWaveRecDlg::Rec(bool bStart)
{
	if (bStart)
	{
		UpdateData();
		m_WaveIn->DeviceId = m_RDevice.GetCurSel();
		BSTR fileName = m_FileName_Rec.AllocSysString();
		m_WaveRiff_Rec->FileName = fileName;
		SysFreeString(fileName);
	}
	m_WaveIn->Active = bStart;
}

void CWaveRecDlg::Play(bool bStart)
{
	if (bStart)
	{
		UpdateData();

		m_WaveRiff_Play->Loop = m_PLoop.GetCheck() == 1;

		BSTR fileName = m_FileName_Play.AllocSysString();
		m_WaveRiff_Play->FileName = fileName;
		SysFreeString(fileName);
	}

	m_WaveRiff_Play->Active = bStart;

	if (bStart)
	{
		char buffer[10];
		itoa(m_WaveRiff_Play->PcmBitsPerSample, buffer, 10);
		m_PBits.SetWindowText(buffer);
		itoa(m_WaveRiff_Play->PcmSamplesPerSec, buffer, 10);
		m_PSamplingRate.SetWindowText(buffer);
		m_PStereo.SetCheck(m_WaveRiff_Play->PcmNumChannels == 1 ? 0 : 1);
	}
}

void CWaveRecDlg::OnButton1() { Rec(); }

void CWaveRecDlg::OnButton2() { Rec(false); }

void CWaveRecDlg::OnButton3() { Play(); }

void CWaveRecDlg::OnButton4() { Play(false); }

void CWaveRecDlg::OnClose() 
{
	VCUninit();
	CDialog::OnClose();
}

void CWaveRecDlg::OnButton5() 
{
	char buffer[5];
	itoa(m_WaveIn->GetMixerId(m_RDevice.GetCurSel(), true), buffer, 10);
	string params = "/r /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}

void CWaveRecDlg::OnButton6() 
{
	char buffer[5];
	itoa(m_WaveOut->GetMixerId(m_PDevice.GetCurSel(), false), buffer, 10);
	string params = "/p /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}

void CWaveRecDlg::OnTimer(UINT nIDEvent) 
{
	char buffer[10], buffer2[10];

	itoa(m_WaveIn->DataSizeOut, buffer, 10);
	string recorded(string("bytes recorded: ") + string(buffer));

	itoa(m_WaveOut->DataSizeIn, buffer, 10);
	itoa(m_WaveRiff_Play->FileSize, buffer2, 10);
	string played(string("bytes played back: ") + string(buffer) + "/" + string(buffer2));

	CWnd* pWnd;
	pWnd = GetDlgItem(IDC_STATIC1);
	pWnd->SetWindowText(recorded.c_str());
	pWnd = GetDlgItem(IDC_STATIC2);
	pWnd->SetWindowText(played.c_str());

	m_RecBtnStart.EnableWindow(!m_WaveRiff_Rec->Active);
	m_RecBtnStop.EnableWindow(m_WaveRiff_Rec->Active);
	m_PlayBtnStart.EnableWindow(!m_WaveRiff_Play->Active);
	m_PlayBtnStop.EnableWindow(m_WaveRiff_Play->Active);
	
	CDialog::OnTimer(nIDEvent);
}

void CWaveRecDlg::OnButton7() 
{
	if (m_WaveRiff_Rec->FormatChoose("Sound quality", reinterpret_cast<long>(m_hWnd)))
	{
		m_WaveIn->PcmBitsPerSample = m_WaveRiff_Rec->PcmBitsPerSample;
		m_WaveIn->PcmSamplesPerSec = m_WaveRiff_Rec->PcmSamplesPerSec;
		m_WaveIn->PcmNumChannels = m_WaveRiff_Rec->PcmNumChannels;
	}
}
